## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 8;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global common_description %{expand:
Highway is a C++ library for SIMD (Single Instruction, Multiple Data), i.e.
applying the same operation to 'lanes'.}

Name:           highway
Version:        1.0.1
Release:        %autorelease -e 0.riscv64
Summary:        Efficient and performance-portable SIMD

License:        ASL 2.0
URL:            https://github.com/google/highway
Source0:        %url/archive/%{version}/%{name}-%{version}.tar.gz

Patch10:        96d1d5f788703eb3dd3a0f62d36a410f92d22666.patch
Patch11:        debian-riscv.patch
Patch12:        riscv-use-rdtime.patch

BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  gtest-devel
BuildRequires:  libatomic

%description
%common_description

%package        devel
Summary:        Development files for Highway
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
%{common_description}

Development files for Highway.

%package        doc
Summary:        Documentation for Highway
BuildArch:      noarch

%description doc
%{common_description}

Documentation for Highway.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%ifarch riscv64
export CFLAGS="%optflags -DHWY_COMPILE_ONLY_EMU128 -DHWY_DISABLED_TARGETS=HWY_RVV"
export CXXFLAGS="%optflags -DHWY_COMPILE_ONLY_EMU128 -DHWY_DISABLED_TARGETS=HWY_RVV"
%endif
%cmake -DHWY_SYSTEM_GTEST:BOOL=ON
%cmake_build

%install
%cmake_install

%check
%ctest

%files
%license LICENSE
%{_libdir}/libhwy.so.1
%{_libdir}/libhwy.so.%{version}
%{_libdir}/libhwy_contrib.so.1
%{_libdir}/libhwy_contrib.so.%{version}
%{_libdir}/libhwy_test.so.1
%{_libdir}/libhwy_test.so.%{version}

%files devel
%license LICENSE
%{_includedir}/hwy/
%{_libdir}/libhwy.so
%{_libdir}/libhwy_contrib.so
%{_libdir}/libhwy_test.so
%{_libdir}/pkgconfig/libhwy.pc
%{_libdir}/pkgconfig/libhwy-contrib.pc
%{_libdir}/pkgconfig/libhwy-test.pc

%files doc
%license LICENSE
%doc g3doc hwy/examples

%changelog
* Mon Oct 17 2022 David Abdurachmanov <davidlt@rivosinc.com> 1.0.1-8.0.riscv64
- Try again, fix patch

* Mon Oct 17 2022 David Abdurachmanov <davidlt@rivosinc.com> 1.0.1-7.0.riscv64
- Misc. riscv64 changes

* Mon Oct 17 2022 David Abdurachmanov <davidlt@rivosinc.com> 1.0.1-6.0.riscv64
- Try HWY_COMPILE_ONLY_SCALAR

* Mon Oct 17 2022 David Abdurachmanov <davidlt@rivosinc.com> 1.0.1-5.0.riscv64
- Fix march for riscv64

* Sun Oct 16 2022 David Abdurachmanov <davidlt@rivosinc.com> 1.0.1-4.0.riscv64
- Try again

* Sun Oct 16 2022 David Abdurachmanov <davidlt@rivosinc.com> 1.0.1-3.0.riscv64
- Try a different approach for disabling RVV

* Sun Oct 16 2022 David Abdurachmanov <davidlt@rivosinc.com> 1.0.1-2.0.riscv64
- Attempt to disable RVV

* Sun Sep 18 2022 Robert-André Mauchin <zebob.m@gmail.com> 1.0.1-1
- Update to 1.0.1

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.17.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sun Jun 19 2022 Robert-André Mauchin <zebob.m@gmail.com> 0.17.0-1
- Update to 0.17.0 Close: rhbz#2056027

* Fri Jan 21 2022 Robert-André Mauchin <zebob.m@gmail.com> 0.15.0-4
- Temporary fix for bug 398

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.15.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Dec 17 2021 Robert-André Mauchin <zebob.m@gmail.com> 0.15.0-2
- Remove unused patch

* Sun Nov 21 2021 Robert-André Mauchin <zebob.m@gmail.com> 0.15.0-1
- Update to 0.15.0 Close: rhbz#1997317

* Wed Aug 18 2021 Robert-André Mauchin <zebob.m@gmail.com> 0.14.1-2
- Add patch to fix missing cast on ppc64le

* Wed Aug 18 2021 Robert-André Mauchin <zebob.m@gmail.com> 0.14.1-1
- Update to 0.14.1 Close: rhbz#1988346

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.12.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sun Jun 13 13:04:25 CEST 2021 Robert-André Mauchin <zebob.m@gmail.com> - 0.12.2-1
- Update to 0.12.2

* Sun May 23 19:03:29 CEST 2021 Robert-André Mauchin <zebob.m@gmail.com> - 0.12.1-1
- Update to 0.12.0
- Close: rhbz#1963675

* Mon May 17 18:03:58 CEST 2021 Robert-André Mauchin <zebob.m@gmail.com> - 0.12.0-1.20210518git376a400
- Initial RPM

